import polling
import glibtop

import os, stat


class Memory:

    def __init__(self):

        self.get_ram         = polling.wrap(self.__poll_mem, 0.5, 0)
        self.get_swap        = polling.wrap(self.__poll_mem, 0.5, 1)


    #
    #:function get_ram | | Returns total amount of RAM, used RAM and
    #                      free RAM.
    #:  param: | |
    #:  return Three int values: Total amount of installed RAM,
    #          used RAM and free RAM.
    #:/function
    #

    #
    #:function get_swap | | Returns total amount of swap, used swap
    #                       and free swap.
    #:  param | |
    #:  return Three int values: Total amount of swap space,
    #          used swap space and free swap space.
    #:/function
    #


    def __poll_mem(self, mode):

        # RAM
        if (mode == 0):
            total, used, free = glibtop.get_mem()[:3]

        # Swap
        elif (mode == 1):
            total, used, free = glibtop.get_swap()[:3]

        return (total, used) #, free)
